<?php
/*---------------------------------------------------------------*/
/*
    Titre : Calcul de Pi                                                                                                  
                                                                                                                          
    URL   : https://phpsources.net/code_s.php?id=907
    Date dition     : 14 Fv 2019                                                                                        
    Date mise  jour : 14 Aout 2019
                                                                                      
    Rapport de la maj:                                                                                                    
    - fonctionnement du code vérifié                                                                                    
    - modification de la description                                                                                      
*/
/*---------------------------------------------------------------*/

      function pi_calcul($nb){
     // on utilise la methode Salamin/Brent 
      // un pur site sur pi : www.pi314.net 
      
      $nb += 5; 
      // $nb est augmente pour releguer les chiffres non 
      // significatif assez loin. 
      bcscale($nb); 
      // bien entendu, le temps de calcul augmente tres vite avec 
      // le nombre de decimales demandees 
      
      $a[0] = 1; 
      $b[0] = bcdiv(1, bcsqrt(2)); 
      $da = $a[0]; 
      $db = $b[0]; 
      
      $somme = 0; 
      $exact = 2; 
     // exact contient le nombre de decimales exactes pour cette 
     // methode de calcul. En fait, l'estimation est rapidement 
     // sous evaluee, mais a dessin 
      $retour = 0; 
      for($i=1; $nb > $exact - 5 ; $i++){ 
      $neob = bcsqrt(bcmul($da, $db)); 
      $neoa = bcdiv(bcadd($db , $da), 2); 
      $b[] = $neob; $a[] = $neoa; 
      $da = $neoa; $db = $neob; 
      
      // la somme est calculee en paralelle 
      $somme = bcadd(bcmul(bcpow(2, $i), bcsub(bcmul($a[$i], $a[$i]), bcmul($b[
$i], 
    $b[$i]))), $somme);
      $exact = 2*$exact - 1; 
      } 
      $i --; 
      $diviseur = bcsub(1, bcmul(2 , $somme)); 
      $retour = bcdiv(bcmul(4, bcmul($a[$i], $a[$i])), $diviseur); 
      return substr($retour, 0, $nb - 4); 
      // on retourne le nombre trouve, avec un chiffre de plus que demande, 
      // a l'utilisateur de juger de son utilite. 
      // aucune arrondi autre que ceux de la machine 
    }
?>